%% Aquisio de vdeo
% Neste programa, faremos a aquisio de um vdeo capturado por uma webcam.
% "Setaremos" a taxa de quadros e exibiremos na tela o resultado.
clear all
profile on;

% Adicionando o caminho para as outras funes do trabalho.
addpath ..;

%% Configurando a porta serial
% Usamos a script ConfiguraSerial.m para a configurao da porta serial
ConfiguraSerial;

%% Configurando trmino da exibio do vdeo
% Tecla a ser pressionada para interrupo da captura
defaultKey = 'q';
deadKey = char(1);
% Usa-se uma figura para monitorar o pressionamento da tecla defaultKey.
% Aqui, configuramos a figura:
% hf = figure('Tag','KEY_CATCHER', ...
%         'Units','Normalized','Position',[1.1 1.1 .2 .1], ...
%         'Menubar','None','CurrentCharacter',deadKey, ...
%         'IntegerHandle','On','NumberTitle','Off', ...
%         'Name','EDGE2JAVA','Resize','on', ...
%         'HandleVisibility','off');
% Ativa a figura
hf = figure(1);

set(hf,'Tag','KEY_CATCHER', ...
        'Units','Normalized','Position',[1.1 1.1 .2 .1], ...
        'Menubar','None','CurrentCharacter',deadKey, ...
        'IntegerHandle','On','NumberTitle','Off', ...
        'Name','EDGE2JAVA','Resize','on', ...
        'HandleVisibility','on');
title('Aperte "q" para sair...')
drawnow

%% Iniciando a captura
% Iniciamos a comunicao com a porta serial do PC
fopen(serialUm);

% Recebendo informaes do tamanho da imagem
tamanho(1) = uint16(fscanf(serialUm,'%s')); % altura
tamanho(2) = uint16(fscanf(serialUm,'%s')); % largura
tamanho(3) = uint16(fscanf(serialUm,'%s')); % numero de planos

%% Exibindo o vdeo na tela
% Para exibir o vdeo na tela, usamos a seguinte sequncia:

% Criamos um loop infinito
display('Selecione a figura e aperte a tecla "q" para sair.')
while true;
    
    % Pega a imagem enviada do outro lado
    datajpeg = fscanf(serialUm);
    
    % Converte para bmp
    data = JPEG2BMP(datajpeg,'hd',tamanho);
    
    % Mostrando a imagem na tela
    imshow(data);
    
    % V se foi pressionada a tecla de parada
    cc = get(hf,'CurrentCharacter');
    if strcmpi(cc,defaultKey)
        break;
    end
    
end

%% Liberando as instncias
delete(serialUm);
close(hf);